--- /homez.786/ridinteadu/_serious_analysis/van_21.0.0/dolibarr-21.0.0/htdocs/stripe/admin/stripe.php	2025-03-03 15:58:17.000000000 +0000
+++ /homez.786/ridinteadu/seriousbeta/dolibarr/htdocs/stripe/admin/stripe.php	2025-05-06 13:40:12.082202000 +0000
@@ -502,88 +766,88 @@
 // Activate Bancontact
 if (getDolGlobalInt('MAIN_FEATURES_LEVEL') >= 2) {	// TODO Not used by current code
 	print '<tr class="oddeven"><td>';
-	print $langs->trans("STRIPE_BANCONTACT").'</td><td>';
+	print $langs->trans("STRIPE_BANCONTACT") . '</td><td>';
 	if ($conf->use_javascript_ajax) {
 		print ajax_constantonoff('STRIPE_BANCONTACT');
 	} else {
 		$arrval = array('0' => $langs->trans("No"), '1' => $langs->trans("Yes"));
 		print $form->selectarray("STRIPE_BANCONTACT", $arrval, $conf->global->STRIPE_BANCONTACT);
 	}
-	print ' &nbsp; <span class="opacitymedium">'.$langs->trans("ExampleOnlyForBECustomers").'</span>';
+	print ' &nbsp; <span class="opacitymedium">' . $langs->trans("ExampleOnlyForBECustomers") . '</span>';
 	print '</td></tr>';
 }
 
 // Activate iDEAL
 if (getDolGlobalInt('MAIN_FEATURES_LEVEL') >= 2) {	// TODO Not used by current code
 	print '<tr class="oddeven"><td>';
-	print $langs->trans("STRIPE_IDEAL").'</td><td>';
+	print $langs->trans("STRIPE_IDEAL") . '</td><td>';
 	if ($conf->use_javascript_ajax) {
 		print ajax_constantonoff('STRIPE_IDEAL');
 	} else {
 		$arrval = array('0' => $langs->trans("No"), '1' => $langs->trans("Yes"));
 		print $form->selectarray("STRIPE_IDEAL", $arrval, $conf->global->STRIPE_SEPA_DIRECT_DEBIT);
 	}
-	print ' &nbsp; <span class="opacitymedium">'.$langs->trans("ExampleOnlyForNLCustomers").'</span>';
+	print ' &nbsp; <span class="opacitymedium">' . $langs->trans("ExampleOnlyForNLCustomers") . '</span>';
 	print '</td></tr>';
 }
 
 // Activate Giropay
 if (getDolGlobalInt('MAIN_FEATURES_LEVEL') >= 2) {	// TODO Not used by current code
 	print '<tr class="oddeven"><td>';
-	print $langs->trans("STRIPE_GIROPAY").'</td><td>';
+	print $langs->trans("STRIPE_GIROPAY") . '</td><td>';
 	if ($conf->use_javascript_ajax) {
 		print ajax_constantonoff('STRIPE_GIROPAY');
 	} else {
 		$arrval = array('0' => $langs->trans("No"), '1' => $langs->trans("Yes"));
 		print $form->selectarray("STRIPE_GIROPAY", $arrval, $conf->global->STRIPE_GIROPAY);
 	}
-	print ' &nbsp; <span class="opacitymedium">'.$langs->trans("ExampleOnlyForDECustomers").'</span>';
+	print ' &nbsp; <span class="opacitymedium">' . $langs->trans("ExampleOnlyForDECustomers") . '</span>';
 	print '</td></tr>';
 }
 
 // Activate Sofort
 if (getDolGlobalInt('MAIN_FEATURES_LEVEL') >= 2) {	// TODO Not used by current code
 	print '<tr class="oddeven"><td>';
-	print $langs->trans("STRIPE_SOFORT").'</td><td>';
+	print $langs->trans("STRIPE_SOFORT") . '</td><td>';
 	if ($conf->use_javascript_ajax) {
 		print ajax_constantonoff('STRIPE_SOFORT');
 	} else {
 		$arrval = array('0' => $langs->trans("No"), '1' => $langs->trans("Yes"));
 		print $form->selectarray("STRIPE_SOFORT", $arrval, $conf->global->STRIPE_SOFORT);
 	}
-	print ' &nbsp; <span class="opacitymedium">'.$langs->trans("ExampleOnlyForATBEDEITNLESCustomers").'</span>';
+	print ' &nbsp; <span class="opacitymedium">' . $langs->trans("ExampleOnlyForATBEDEITNLESCustomers") . '</span>';
 	print '</td></tr>';
 }
 
 print '<tr class="oddeven"><td>';
-print $langs->trans("CSSUrlForPaymentForm").'</td><td>';
-print '<input class="width500" type="text" name="ONLINE_PAYMENT_CSS_URL" value="' . getDolGlobalString('ONLINE_PAYMENT_CSS_URL').'">';
-print ' &nbsp; <span class="opacitymedium">'.$langs->trans("Example").': http://mysite/mycss.css</span>';
+print $langs->trans("CSSUrlForPaymentForm") . '</td><td>';
+print '<input class="width500" type="text" name="ONLINE_PAYMENT_CSS_URL" value="' . getDolGlobalString('ONLINE_PAYMENT_CSS_URL') . '">';
+print ' &nbsp; <span class="opacitymedium">' . $langs->trans("Example") . ': http://mysite/mycss.css</span>';
 print '</td></tr>';
 
 print '<tr class="oddeven"><td>';
-print $langs->trans("MessageForm").'</td><td>';
+print $langs->trans("MessageForm") . '</td><td>';
 $doleditor = new DolEditor('ONLINE_PAYMENT_MESSAGE_FORM', getDolGlobalString("ONLINE_PAYMENT_MESSAGE_FORM"), '', 100, 'dolibarr_details', 'In', false, true, true, ROWS_2, '90%');
 $doleditor->Create();
 print '</td></tr>';
 
 print '<tr class="oddeven"><td>';
-print $langs->trans("MessageOK").'</td><td>';
+print $langs->trans("MessageOK") . '</td><td>';
 $doleditor = new DolEditor('ONLINE_PAYMENT_MESSAGE_OK', getDolGlobalString("ONLINE_PAYMENT_MESSAGE_OK"), '', 100, 'dolibarr_details', 'In', false, true, true, ROWS_2, '90%');
 $doleditor->Create();
 print '</td></tr>';
 
 print '<tr class="oddeven"><td>';
-print $langs->trans("MessageKO").'</td><td>';
+print $langs->trans("MessageKO") . '</td><td>';
 $doleditor = new DolEditor('ONLINE_PAYMENT_MESSAGE_KO', getDolGlobalString("ONLINE_PAYMENT_MESSAGE_KO"), '', 100, 'dolibarr_details', 'In', false, true, true, ROWS_2, '90%');
 $doleditor->Create();
 print '</td></tr>';
 
 print '<tr class="oddeven"><td>';
-print $langs->trans("ONLINE_PAYMENT_SENDEMAIL").'</td><td>';
+print $langs->trans("ONLINE_PAYMENT_SENDEMAIL") . '</td><td>';
 print img_picto('', 'email', 'class="pictofixedwidth"');
-print '<input class="minwidth200" type="text" name="ONLINE_PAYMENT_SENDEMAIL" value="' . getDolGlobalString('ONLINE_PAYMENT_SENDEMAIL').'">';
-print ' &nbsp; <span class="opacitymedium">'.$langs->trans("Example").': myemail@myserver.com, Payment service &lt;myemail2@myserver2.com&gt;</span>';
+print '<input class="minwidth200" type="text" name="ONLINE_PAYMENT_SENDEMAIL" value="' . getDolGlobalString('ONLINE_PAYMENT_SENDEMAIL') . '">';
+print ' &nbsp; <span class="opacitymedium">' . $langs->trans("Example") . ': myemail@myserver.com, Payment service &lt;myemail2@myserver2.com&gt;</span>';
 print '</td></tr>';
 
 print '</table>';
@@ -595,16 +859,16 @@
 print '<table class="noborder centpercent">';
 
 print '<tr class="liste_titre">';
-print '<td>'.$langs->trans("UrlGenerationParameters").'</td>';
-print '<td>'.$langs->trans("Value").'</td>';
+print '<td>' . $langs->trans("UrlGenerationParameters") . '</td>';
+print '<td>' . $langs->trans("Value") . '</td>';
 print "</tr>\n";
 
 // Payment token for URL
 print '<tr class="oddeven"><td>';
-print $langs->trans("SecurityToken").'</td><td>';
-print '<input class="minwidth300"  type="text" id="PAYMENT_SECURITY_TOKEN" name="PAYMENT_SECURITY_TOKEN" value="' . getDolGlobalString('PAYMENT_SECURITY_TOKEN').'">';
+print $langs->trans("SecurityToken") . '</td><td>';
+print '<input class="minwidth300"  type="text" id="PAYMENT_SECURITY_TOKEN" name="PAYMENT_SECURITY_TOKEN" value="' . getDolGlobalString('PAYMENT_SECURITY_TOKEN') . '">';
 if (!empty($conf->use_javascript_ajax)) {
-	print '&nbsp;'.img_picto($langs->trans('Generate'), 'refresh', 'id="generate_token" class="linkobject"');
+	print '&nbsp;' . img_picto($langs->trans('Generate'), 'refresh', 'id="generate_token" class="linkobject"');
 }
 if (getDolGlobalString('PAYMENT_SECURITY_ACCEPT_ANY_TOKEN')) {
 	$langs->load("errors");
@@ -613,7 +877,7 @@
 print '</td></tr>';
 
 print '<tr class="oddeven"><td>';
-print $langs->trans("SecurityTokenIsUnique").'</td><td>';
+print $langs->trans("SecurityTokenIsUnique") . '</td><td>';
 if ($conf->use_javascript_ajax) {
 	print ajax_constantonoff('PAYMENT_SECURITY_TOKEN_UNIQUE', array(), null, 0, 0, 1);
 } else {
@@ -622,6 +886,26 @@
 }
 print '</td></tr>';
 
+
+
+
+
+//MODIF JOSE
+// $date_start = getDolGlobalInt('STRIPE_FEES_DATE_START');
+// $date_end = getDolGlobalInt('STRIPE_FEES_DATE_END');
+
+
+// print '<tr class="oddeven"><td>';
+// print $langs->trans("StartDateForFeesImport") . '</td><td>';
+// print $form->selectDate($date_start ? $date_start : '', 'date_start', 0, 0, 0, '', 1, 0, 0, '', '', '', '', 1, '', '', 'tzserver');
+// print '</td></tr>';
+
+// print '<tr class="oddeven"><td>';
+// print $langs->trans("EndDateForFeesImport") . '</td><td>';
+// print $form->selectDate($date_end ? $date_end : '', 'date_end', 0, 0, 0, '', 1, 0, 0, '', '', '', '', 1, '', '', 'tzserver');
+// print '</td></tr>';
+//END MODIF
+
 print '</table>';
 print '</div>';
 
@@ -633,21 +917,102 @@
 
 print '<br><br>';
 
+print '<div class="div-table-responsive-no-min">';
+print '<table class="noborder centpercent">';
+
+$date_start = GETPOSTISSET('date_startday') ? dol_mktime(0, 0, 0, GETPOST('date_startmonth', 'int'), GETPOST('date_startday', 'int'), GETPOST('date_startyear', 'int')) : getDolGlobalInt('STRIPE_FEES_DATE_START');
+$date_end = GETPOSTISSET('date_endday') ? dol_mktime(23, 59, 59, GETPOST('date_endmonth', 'int'), GETPOST('date_endday', 'int'), GETPOST('date_endyear', 'int')) : getDolGlobalInt('STRIPE_FEES_DATE_END');
+
+print '<form method="POST" action="' . $_SERVER['PHP_SELF'] . '">';
+print '<input type="hidden" name="token" value="' . newToken() . '">';
+print '<input type="hidden" name="action" value="manual_update_stripe_fees">';
+
+
+print '<tr class="liste_titre">';
+print '<td>' . $langs->trans("Update des fees") . '</td>';
+print '<td class="right">' . $langs->trans("Valeur") . '</td>';
+print "</tr>\n";
+
+print '<tr class="oddeven"><td>';
+print $langs->trans("StripeAutoAddFeesToBank") . '<td class="right">';
+if ($conf->use_javascript_ajax) {
+	print ajax_constantonoff('STRIPE_AUTO_ADD_FEES_TO_BANK', array(), null, 0, 0, 1);
+} else {
+	$arrval = array('0' => $langs->trans("No"), '1' => $langs->trans("Yes"));
+	print $form->selectarray("STRIPE_AUTO_ADD_FEES_TO_BANK", $arrval, getDolGlobalInt('STRIPE_AUTO_ADD_FEES_TO_BANK'));
+}
+print '</td></tr>';
+
+if (getDolGlobalInt('STRIPE_AUTO_ADD_FEES_TO_BANK')) {
+
+	print '<tr class="oddeven">';
+	print '<td>' . $langs->trans("PeriodeToUpdate") . '</td>';
+	print '<td class="right">';
+
+	print '<span style="margin-right: 10px;">' . $langs->trans("DateStart") . '</span>';
+	print $form->selectDate($date_start ?: '', 'date_start', 0, 0, 0, '', 1, 0, 0, '', '', '', '', 1, '', '', 'tzserver');
+
+
+	print '<span style="margin-right: 10px;">' . $langs->trans("DateEnd") . '</span>';
+	print $form->selectDate($date_end ?: '', 'date_end', 0, 0, 0, '', 1, 0, 0, '', '', '', '', 1, '', '', 'tzserver');
+
+	print '<input type="submit" class="button" value="' . $langs->trans("UpdateFees") . '">';
+
+
+	print '</td>';
+	print '</tr>';
+}
+
+print '</form>';
+
+$date_start2 = dol_mktime(0, 0, 0, GETPOST('date_start2month', 'int'), GETPOST('date_start2day', 'int'), GETPOST('date_start2year', 'int'));
+$date_end2 = dol_mktime(23, 59, 59, GETPOST('date_end2month', 'int'), GETPOST('date_end2day', 'int'), GETPOST('date_end2year', 'int'));
+
+
+print '<form method="POST" action="' . $_SERVER['PHP_SELF'] . '">';
+print '<input type="hidden" name="token" value="' . newToken() . '">';
+print '<input type="hidden" name="action" value="manual_reconcile_stripe_payments">';
+
+print '<tr class="oddeven">';
+print '<td>' . $langs->trans("PeriodeToreconciliate") . '</td>';
+print '<td class="right">';
+
+
+print '<span style="margin-right: 10px;">' . $langs->trans("DateStart") . '</span>';
+print $form->selectDate($date_start2 ?: '', 'date_start2', 0, 0, 0, '', 1, 0, 0, '', '', '', '', 1, '', '', 'tzserver');
+
+print '<span style="margin-right: 10px;">' . $langs->trans("DateEnd") . '</span>';
+print $form->selectDate($date_end2 ?: '', 'date_end2', 0, 0, 0, '', 1, 0, 0, '', '', '', '', 1, '', '', 'tzserver');
+
+print '<input type="submit" class="button" value="' . $langs->trans("ReconcileButton") . '">';
+print '</td>';
+print '</tr>';
+print '</form>';
+
+
+
+print '</table>';
+print '</div>';
+
+
+
+print '<br><br>';
+
 
 $token = '';
 
-include DOL_DOCUMENT_ROOT.'/core/tpl/onlinepaymentlinks.tpl.php';
+include DOL_DOCUMENT_ROOT . '/core/tpl/onlinepaymentlinks.tpl.php';
 
-print info_admin($langs->trans("ExampleOfTestCreditCard", '4242424242424242 (no 3DSecure) or 4000000000003063 (3DSecure required) or 4000002760003184 (3DSecure2 required on all transaction) or 4000003800000446 (3DSecure2 required, the off-session allowed)', '4000000000000101', '4000000000000069', '4000000000000341').'. '.$langs->trans('SeeAlso', 'https://docs.stripe.com/testing?testing-method=card-numbers'));
+print info_admin($langs->trans("ExampleOfTestCreditCard", '4242424242424242 (no 3DSecure) or 4000000000003063 (3DSecure required) or 4000002760003184 (3DSecure2 required on all transaction) or 4000003800000446 (3DSecure2 required, the off-session allowed)', '4000000000000101', '4000000000000069', '4000000000000341') . '. ' . $langs->trans('SeeAlso', 'https://docs.stripe.com/testing?testing-method=card-numbers'));
 
 if (getDolGlobalString('STRIPE_SEPA_DIRECT_DEBIT')) {
-	print info_admin($langs->trans("ExampleOfTestBankAcountForSEPA", 'AT611904300234573201 (pending->succeed) or AT861904300235473202 (pending->failed)').'. '.$langs->trans('SeeAlso', 'https://docs.stripe.com/testing?payment-method=sepa-direct-debit'));
+	print info_admin($langs->trans("ExampleOfTestBankAcountForSEPA", 'AT611904300234573201 (pending->succeed) or AT861904300235473202 (pending->failed)') . '. ' . $langs->trans('SeeAlso', 'https://docs.stripe.com/testing?payment-method=sepa-direct-debit'));
 }
 
 
 
 if (!empty($conf->use_javascript_ajax)) {
-	print "\n".'<script type="text/javascript">';
+	print "\n" . '<script type="text/javascript">';
 	print '$(document).ready(function () {
 	            $("#apidoc").hide();
 	            $("#apidoca").click(function() {

########## stripe/charge.php
--- /homez.786/ridinteadu/_serious_analysis/van_21.0.0/dolibarr-21.0.0/htdocs/stripe/charge.php	2025-03-03 15:58:17.000000000 +0000
+++ /homez.786/ridinteadu/seriousbeta/dolibarr/htdocs/stripe/charge.php	2025-03-26 09:08:29.319289000 +0000
@@ -21,15 +21,15 @@
 
 // Load Dolibarr environment
 require '../main.inc.php';
-require_once DOL_DOCUMENT_ROOT.'/societe/class/societe.class.php';
-require_once DOL_DOCUMENT_ROOT.'/adherents/class/adherent.class.php';
-require_once DOL_DOCUMENT_ROOT.'/stripe/class/stripe.class.php';
+require_once DOL_DOCUMENT_ROOT . '/societe/class/societe.class.php';
+require_once DOL_DOCUMENT_ROOT . '/adherents/class/adherent.class.php';
+require_once DOL_DOCUMENT_ROOT . '/stripe/class/stripe.class.php';
 //require_once DOL_DOCUMENT_ROOT.'/core/lib/stripe.lib.php';
-require_once DOL_DOCUMENT_ROOT.'/compta/bank/class/account.class.php';
-require_once DOL_DOCUMENT_ROOT.'/commande/class/commande.class.php';
-require_once DOL_DOCUMENT_ROOT.'/compta/facture/class/facture.class.php';
+require_once DOL_DOCUMENT_ROOT . '/compta/bank/class/account.class.php';
+require_once DOL_DOCUMENT_ROOT . '/commande/class/commande.class.php';
+require_once DOL_DOCUMENT_ROOT . '/compta/facture/class/facture.class.php';
 if (isModEnabled('accounting')) {
-	require_once DOL_DOCUMENT_ROOT.'/accountancy/class/accountingjournal.class.php';
+	require_once DOL_DOCUMENT_ROOT . '/accountancy/class/accountingjournal.class.php';
 }
 
 /**
@@ -100,28 +100,28 @@
 	$totalnboflines = '';
 	$moreforfilter = '';
 	$list = null;
-	if (GETPOSTISSET('starting_after_'.$page)) {
-		$option['starting_after'] = GETPOST('starting_after_'.$page, 'alphanohtml');
+	if (GETPOSTISSET('starting_after_' . $page)) {
+		$option['starting_after'] = GETPOST('starting_after_' . $page, 'alphanohtml');
 	}
-	print '<form method="POST" action="'.$_SERVER["PHP_SELF"].'">';
+	print '<form method="POST" action="' . $_SERVER["PHP_SELF"] . '">';
 	if ($optioncss != '') {
-		print '<input type="hidden" name="optioncss" value="'.$optioncss.'">';
+		print '<input type="hidden" name="optioncss" value="' . $optioncss . '">';
 	}
 
-	print '<input type="hidden" name="token" value="'.newToken().'">';
+	print '<input type="hidden" name="token" value="' . newToken() . '">';
 	print '<input type="hidden" name="formfilteraction" id="formfilteraction" value="list">';
 	print '<input type="hidden" name="action" value="list">';
-	print '<input type="hidden" name="sortfield" value="'.$sortfield.'">';
-	print '<input type="hidden" name="sortorder" value="'.$sortorder.'">';
-	print '<input type="hidden" name="page" value="'.$page.'">';
+	print '<input type="hidden" name="sortfield" value="' . $sortfield . '">';
+	print '<input type="hidden" name="sortorder" value="' . $sortorder . '">';
+	print '<input type="hidden" name="page" value="' . $page . '">';
 
 	$title = $langs->trans("StripeChargeList");
-	$title .= ($stripeacc ? ' (Stripe connection with Stripe OAuth Connect account '.$stripeacc.')' : ' (Stripe connection with keys from Stripe module setup)');
+	$title .= ($stripeacc ? ' (Stripe connection with Stripe OAuth Connect account ' . $stripeacc . ')' : ' (Stripe connection with keys from Stripe module setup)');
 
 	print_barre_liste($title, $page, $_SERVER["PHP_SELF"], $param, $sortfield, $sortorder, '', $num, $totalnboflines, 'title_accountancy.png', 0, '', 'hidepaginationprevious', $limit);
 
 	print '<div class="div-table-responsive">';
-	print '<table class="tagtable liste'.($moreforfilter ? " listwithfilterbefore" : "").'">'."\n";
+	print '<table class="tagtable liste' . ($moreforfilter ? " listwithfilterbefore" : "") . '">' . "\n";
 
 	print '<tr class="liste_titre">';
 	print_liste_field_titre("StripePaymentId", $_SERVER["PHP_SELF"], "", "", "", "", $sortfield, $sortorder);
@@ -147,18 +147,21 @@
 
 		//if (!empty($contextpage) && $contextpage != $_SERVER["PHP_SELF"]) $param .= '&contextpage='.urlencode($contextpage);
 		if ($limit > 0 && $limit != $conf->liste_limit) {
-			$param .= '&limit='.((int) $limit);
+			$param .= '&limit=' . ((int) $limit);
 		}
-		$param .= '&starting_after_'.($page + 1).'='.$list->data[($limit - 1)]->id;
+		$param .= '&starting_after_' . ($page + 1) . '=' . $list->data[($limit - 1)]->id;
 		//$param.='&ending_before_'.($page+1).'='.$list->data[($limit-1)]->id;
 	} catch (Exception $e) {
-		print '<tr><td colspan="8">'.$e->getMessage().'</td></td>';
+		print '<tr><td colspan="8">' . $e->getMessage() . '</td></td>';
 	}
 
 	//print $list;
 	$i = 0;
 	if (!empty($list)) {
 		foreach ($list->data as $charge) {
+
+			
+
 			'@phan-var-force \Stripe\Charge $charge';  // TStripeObject suggested, but is a template
 			if ($i >= $limit) {
 				break;
@@ -169,9 +172,9 @@
 			} elseif ($charge->paid == '1') {
 				$status = img_picto($langs->trans((string) $charge->status), 'statut4');
 			} else {
-				$label = $langs->trans("Message").": ".$charge->failure_message."<br>";
-				$label .= $langs->trans("Network").": ".$charge->outcome->network_status."<br>";
-				$label .= $langs->trans("Status").": ".$langs->trans((string) $charge->outcome->seller_message);
+				$label = $langs->trans("Message") . ": " . $charge->failure_message . "<br>";
+				$label .= $langs->trans("Network") . ": " . $charge->outcome->network_status . "<br>";
+				$label .= $langs->trans("Status") . ": " . $langs->trans((string) $charge->outcome->seller_message);
 				$status = $form->textwithpicto(img_picto($langs->trans((string) $charge->status), 'statut8'), $label, -1);
 			}
 
@@ -218,34 +221,35 @@
 			print '<tr class="oddeven">';
 
 			if (!empty($stripeacc)) {
-				$connect = $stripeacc.'/';
+				$connect = $stripeacc . '/';
 			} else {
 				$connect = '';
 			}
 
 			// Ref
-			$url = 'https://dashboard.stripe.com/'.$connect.'test/payments/'.$charge->id;
+			$url = 'https://dashboard.stripe.com/' . $connect . 'test/payments/' . $charge->id;
 			if ($servicestatus) {
-				$url = 'https://dashboard.stripe.com/'.$connect.'payments/'.$charge->id;
+				$url = 'https://dashboard.stripe.com/' . $connect . 'payments/' . $charge->id;
 			}
 			print '<td class="tdoverflowmax150">';
-			print "<a href='".$url."' target='_stripe'>".img_picto($langs->trans('ShowInStripe'), 'globe')." ".$charge->id."</a>";
+			print "<a href='" . $url . "' target='_stripe'>" . img_picto($langs->trans('ShowInStripe'), 'globe') . " " . $charge->id . "</a>";
 			if ($charge->payment_intent) {
-				print '<br><span class="opacitymedium">'.$charge->payment_intent.'</span>';
+				var_dump($charge->payment_intent);
+				print '<br><span class="opacitymedium">' . $charge->payment_intent . '</span>';
 			}
 			print "</td>\n";
 
 			// Stripe customer
 			print '<td class="tdoverflowmax150">';
 			if (isModEnabled('stripe') && !empty($stripeacc)) {
-				$connect = $stripeacc.'/';
+				$connect = $stripeacc . '/';
 			}
-			$url = 'https://dashboard.stripe.com/'.$connect.'test/customers/'.$charge->customer;
+			$url = 'https://dashboard.stripe.com/' . $connect . 'test/customers/' . $charge->customer;
 			if ($servicestatus) {
-				$url = 'https://dashboard.stripe.com/'.$connect.'customers/'.$charge->customer;
+				$url = 'https://dashboard.stripe.com/' . $connect . 'customers/' . $charge->customer;
 			}
 			if (!empty($charge->customer)) {
-				print '<a href="'.$url.'" target="_stripe">'.img_picto($langs->trans('ShowInStripe'), 'globe').' '.$charge->customer.'</a>';
+				print '<a href="' . $url . '" target="_stripe">' . img_picto($langs->trans('ShowInStripe'), 'globe') . ' ' . $charge->customer . '</a>';
 			}
 			print "</td>\n";
 
@@ -264,7 +268,7 @@
 				$object = new Commande($db);
 				$object->fetch($charge->metadata->dol_id);
 				if ($object->id > 0) {
-					print "<a href='".DOL_URL_ROOT."/commande/card.php?id=".$object->id."'>".img_picto('', 'order')." ".$object->ref."</a>";
+					print "<a href='" . DOL_URL_ROOT . "/commande/card.php?id=" . $object->id . "'>" . img_picto('', 'order') . " " . $object->ref . "</a>";
 				} else {
 					print $FULLTAG;
 				}
@@ -272,7 +276,7 @@
 				$object = new Facture($db);
 				$object->fetch($charge->metadata->dol_id);
 				if ($object->id > 0) {
-					print "<a href='".DOL_URL_ROOT."/compta/facture/card.php?facid=".$charge->metadata->dol_id."'>".img_picto('', 'bill')." ".$object->ref."</a>";
+					print "<a href='" . DOL_URL_ROOT . "/compta/facture/card.php?facid=" . $charge->metadata->dol_id . "'>" . img_picto('', 'bill') . " " . $object->ref . "</a>";
 				} else {
 					print $FULLTAG;
 				}
@@ -282,13 +286,13 @@
 			print "</td>\n";
 
 			// Date payment
-			print '<td class="center nowraponall">'.dol_print_date($charge->created, 'dayhour')."</td>\n";
+			print '<td class="center nowraponall">' . dol_print_date($charge->created, 'dayhour') . "</td>\n";
 			// Type
 			print '<td>';
 			print $type;
 			print '</td>';
 			// Amount
-			print '<td class="right"><span class="amount">'.price(($charge->amount - $charge->amount_refunded) / 100, 0, '', 1, - 1, - 1, strtoupper($charge->currency))."</span></td>";
+			print '<td class="right"><span class="amount">' . price(($charge->amount - $charge->amount_refunded) / 100, 0, '', 1, -1, -1, strtoupper($charge->currency)) . "</span></td>";
 			// Status
 			print '<td class="nowraponall">';
 			print $status;

########## stripe/lib/stripe.lib.php
--- /homez.786/ridinteadu/_serious_analysis/van_21.0.0/dolibarr-21.0.0/htdocs/stripe/lib/stripe.lib.php	2025-03-03 15:58:17.000000000 +0000
+++ /homez.786/ridinteadu/seriousbeta/dolibarr/htdocs/stripe/lib/stripe.lib.php	2025-03-26 10:14:51.002969000 +0000
@@ -23,7 +23,7 @@
  *  \brief			Library for common stripe functions
  */
 
-require_once DOL_DOCUMENT_ROOT.'/core/lib/payments.lib.php';
+require_once DOL_DOCUMENT_ROOT . '/core/lib/payments.lib.php';
 
 /**
  *  Define head array for tabs of stripe tools setup pages
@@ -37,7 +37,7 @@
 	$h = 0;
 	$head = array();
 
-	$head[$h][0] = DOL_URL_ROOT."/stripe/admin/stripe.php";
+	$head[$h][0] = DOL_URL_ROOT . "/stripe/admin/stripe.php";
 	$head[$h][1] = $langs->trans("Stripe");
 	$head[$h][2] = 'stripeaccount';
 	$h++;
@@ -70,11 +70,11 @@
 	// Juridical status
 	$line1 = "";
 	if ($fromcompany->forme_juridique_code) {
-		$line1 .= ($line1 ? " - " : "").getFormeJuridiqueLabel((string) $fromcompany->forme_juridique_code);
+		$line1 .= ($line1 ? " - " : "") . getFormeJuridiqueLabel((string) $fromcompany->forme_juridique_code);
 	}
 	// Capital
 	if ($fromcompany->capital) {
-		$line1 .= ($line1 ? " - " : "").$langs->transnoentities("CapitalOf", $fromcompany->capital)." ".$langs->transnoentities("Currency".$conf->currency);
+		$line1 .= ($line1 ? " - " : "") . $langs->transnoentities("CapitalOf", $fromcompany->capital) . " " . $langs->transnoentities("Currency" . $conf->currency);
 	}
 
 	$reg = array();
@@ -85,7 +85,7 @@
 		if (preg_match('/\((.*)\)/i', $field, $reg)) {
 			$field = $reg[1];
 		}
-		$line1 .= ($line1 ? " - " : "").$field.": ".$fromcompany->idprof1;
+		$line1 .= ($line1 ? " - " : "") . $field . ": " . $fromcompany->idprof1;
 	}
 	// Prof Id 2
 	if ($fromcompany->idprof2) {
@@ -93,7 +93,7 @@
 		if (preg_match('/\((.*)\)/i', $field, $reg)) {
 			$field = $reg[1];
 		}
-		$line1 .= ($line1 ? " - " : "").$field.": ".$fromcompany->idprof2;
+		$line1 .= ($line1 ? " - " : "") . $field . ": " . $fromcompany->idprof2;
 	}
 
 	// Second line of company infos
@@ -104,7 +104,7 @@
 		if (preg_match('/\((.*)\)/i', $field, $reg)) {
 			$field = $reg[1];
 		}
-		$line2 .= ($line2 ? " - " : "").$field.": ".$fromcompany->idprof3;
+		$line2 .= ($line2 ? " - " : "") . $field . ": " . $fromcompany->idprof3;
 	}
 	// Prof Id 4
 	if ($fromcompany->idprof4) {
@@ -112,17 +112,145 @@
 		if (preg_match('/\((.*)\)/i', $field, $reg)) {
 			$field = $reg[1];
 		}
-		$line2 .= ($line2 ? " - " : "").$field.": ".$fromcompany->idprof4;
+		$line2 .= ($line2 ? " - " : "") . $field . ": " . $fromcompany->idprof4;
 	}
 	// IntraCommunautary VAT
 	if ($fromcompany->tva_intra != '') {
-		$line2 .= ($line2 ? " - " : "").$langs->transnoentities("VATIntraShort").": ".$fromcompany->tva_intra;
+		$line2 .= ($line2 ? " - " : "") . $langs->transnoentities("VATIntraShort") . ": " . $fromcompany->tva_intra;
 	}
 
-	print '<br><br><hr>'."\n";
-	print '<div class="center"><span style="font-size: 10px;">'."\n";
-	print $fromcompany->name.'<br>';
-	print $line1.'<br>';
+	print '<br><br><hr>' . "\n";
+	print '<div class="center"><span style="font-size: 10px;">' . "\n";
+	print $fromcompany->name . '<br>';
+	print $line1 . '<br>';
 	print $line2;
-	print '</span></div>'."\n";
+	print '</span></div>' . "\n";
 }
+
+//MODIF JOSE
+/**
+ * Add a line on bank account with Stripe fees
+ *
+ * @param string  $ref         Reference to add in the description (e.g. transaction ID)
+ * @param float   $totalamount Fee amount to insert (should be positive, will be inverted in the function)
+ * @param int     $fk_account  ID of the Stripe bank account in Dolibarr
+ * @param string  $stripe_id   Stripe transaction ID (used in num_chq to detect duplicates)
+ * @param int     $date        Payment date (timestamp), default now
+ * @param int     $datev       Value date (timestamp), default now
+ * @return int                 Bank line ID or -1 on error
+ */
+function stripeAddPaymentFeeOnBank($ref, $totalamount, $fk_account, $stripe_id, $date = null, $datev = null)
+{
+	global $db, $conf, $user, $langs;
+
+	$db->begin();
+	$error = 0;
+
+	if (empty($date))  $date = dol_now();
+	if (empty($datev)) $datev = dol_now();
+
+	$amount = 0 - abs($totalamount);
+
+	include_once DOL_DOCUMENT_ROOT . '/compta/bank/class/account.class.php';
+	$acc = new Account($db);
+	$result = $acc->fetch($fk_account);
+	if ($result < 0) {
+		return -1;
+	}
+
+	$label = $langs->trans('StripeFees');
+	if (!empty($ref)) {
+		$label .= " " . $ref;
+	} elseif (!empty($date)) {
+		$label .= " " . dol_print_date($date, 'day');
+	}
+
+	$sql = "SELECT count(*) as count FROM " . MAIN_DB_PREFIX . "bank
+	        WHERE num_chq = '" . $db->escape($stripe_id) . "'
+	          AND fk_account = '" . (int) $fk_account . "'
+	          AND amount = " . (float) $amount;
+	$resql = $db->query($sql);
+	if ($resql) {
+		$obj = $db->fetch_object($resql);
+		if ($obj->count > 0) {
+			dol_syslog("stripeAddPaymentFeeOnBank duplicate found for ID $stripe_id");
+			$db->commit();
+			return 0;
+		} else {
+			dol_syslog("stripeAddPaymentFeeOnBank inserting fee for ID $stripe_id");
+
+			$bank_line_id = $acc->addline(
+				$date,
+				'PRE',
+				$label,
+				$amount,
+				$stripe_id,
+				'',
+				$user,
+				'',
+				'',
+				'',
+				$datev
+			);
+
+			if ($bank_line_id <= 0) {
+				$error++;
+				$db->rollback();
+				return -1;
+			}
+		}
+	} else {
+		$error++;
+		$db->rollback();
+		return -1;
+	}
+
+	$db->commit();
+	return $bank_line_id;
+}
+
+
+function trouverIdTiersParEmail($email)
+{
+	global $db; // Obtenir l'objet de connexion à la base de données de Dolibarr
+
+	// Préparer la requête SQL pour récupérer l'ID du tiers en fonction de l'email
+	// $sql = "SELECT fk_soc FROM llx_socpeople WHERE email = '$email'";
+	$sql = "SELECT fk_soc FROM llx_socpeople WHERE email = '" . $db->escape($email) . "'";
+
+	// Exécuter la requête avec la méthode fetch_array pour obtenir un tableau de résultats
+
+	$result = $db->query($sql);
+	if ($result) {
+		// Récupérer l'ID du tiers
+		$row = $db->fetch_array($result);
+		if ($row) {
+			$idTiers = $row['fk_soc'];
+			return $idTiers;
+		}
+	}
+
+	return false;
+}
+
+function trouverIdFactureParRefClient($refClient)
+{
+	global $db; // Obtenir l'objet de connexion à la base de données de Dolibarr
+
+	// Préparer la requête SQL pour récupérer l'ID de la facture en fonction de la référence client
+	$sql = "SELECT rowid FROM " . MAIN_DB_PREFIX . "facture WHERE ref_client = '" . $db->escape($refClient) . "'";
+
+	// Exécuter la requête avec la méthode query pour obtenir un résultat
+	$result = $db->query($sql);
+	if ($result) {
+		// Récupérer l'ID de la facture
+		$row = $db->fetch_array($result);
+		if ($row) {
+			$idFacture = $row['rowid'];
+			return $idFacture;
+		}
+	}
+
+	return false;
+}
+//END MODIF
\ No newline at end of file

########## stripe/transaction.php
